;*** Oddajnik za 75MHz marker (takt 9.8304MHz) - S53MV - 14/12/2004 ***

;*** Uporaba vrat PICa 16F84 ***
;izbira tipaknaj vhod=RA0,RA1,RA2
;I2C vodilo: SCL=RA3, SDA=RA4
;DAC izhodi=RB0,1,2,3,4,5,6,7

;*** Uporaba RAMa ***
;0C	PISKAC
;0D	OMTX, MMTX, IMTX
;10,11	OMTX, MMTX, IMTX, PISKAC frekvenca tona (korak 6.25Hz)
;12	PISKAC trajanje tona (periode*4)
;13,14	PISKAC akumulator DDSja

;*** Zacetek programa, inicializacije ***
	LIST    P=16F84
	ORG	0
	CALL	INIPIC	;inicializacija vrat PICa
	GOTO	GLAVNI

;*** Inicializacija vrat PICa ***
INIPIC	MOVLW	18	;zacetno stanje vrat A
	MOVWF	5
	MOVLW	0AA	;zacetno stanje vrat B
	MOVWF	6
	BSF	3,5	;postavi PAGE1
	MOVLW	7	;port A: vhodi RA0-2 in izhoda RA3-4
	MOVWF	5	;vpisi TRISA
	MOVLW	0	;port B: izhodi RB0-7
	MOVWF	6	;vpisi TRISB
	BCF	3,5	;postavi PAGE0
	RETURN

;*** Glavna zanka programa ***
GLAVNI	BTFSS	5,0	;vkljucen OM?
	CALL	OMTX
	BTFSS	5,1	;vkljucen MM?
	CALL	MMTX
	BTFSS	5,2	;vkljucen IM?
	CALL	IMTX
	MOVLW	80	;tisina na DAC
	MOVWF	6
	GOTO	GLAVNI

;*** Outer marker TX 400Hz 8 crt *** (0D,10,11)
OMTX	MOVLW	0	;frekvenca 400Hz
	MOVWF	10
	MOVLW	40
	MOVWF	11
	MOVLW	8	;oddaja 8 crt
	MOVWF	0D
OMTX1	MOVLW	2D	;piskanje 180 period ($2D+$0)
	MOVWF	12
	MOVLW	0
	MOVWF	13
	CLRF	14
	CALL	PISKAC
	DECFSZ	0D,1
	GOTO	OMTX1
	RETURN

;*** Middle Marker TX 1300Hz 6 pika-crta *** (0D,10,11)
MMTX	MOVLW	0	;frekvenca 1300Hz
	MOVWF	10
	MOVLW	0D0
	MOVWF	11
	MOVLW	6	;oddaja 6 pika-crta
	MOVWF	0D
MMTX1	MOVLW	1E	;piskanje 117 period ($1E+$C0)
	MOVWF	12
	MOVLW	0C0
	MOVWF	13
	CLRF	14
	CALL	PISKAC
	MOVLW	93	;piskanje 585 period ($93+$C0)
	MOVWF	12
	MOVLW	0C0
	MOVWF	13
	CLRF	14
	CALL	PISKAC
	DECFSZ	0D,1
	GOTO	MMTX1
	RETURN

;*** Inner Marker TX 3000Hz 24 pik *** (0D,10,11)
IMTX	MOVLW	1	;frekvenca 3000Hz
	MOVWF	10
	MOVLW	0E0
	MOVWF	11
	MOVLW	18	;oddaja 24 pik
	MOVWF	0D
IMTX1	MOVLW	44	;piskanje 270 period ($44+$80)
	MOVWF	12
	MOVLW	80
	MOVWF	13
	CLRF	14
	CALL	PISKAC
	DECFSZ	0D,1
	GOTO	IMTX1
	RETURN

;*** Zanka piskaca 24 ukazov, f(10,11) in T(12) *** (0C,12,13,14)
PISKAC	MOVF	10,0	;povecaj stevce (10 ukazov)
	MOVWF	0C
	MOVF	11,0
	ADDWF	14,1
	BTFSC	3,0
	INCF	0C,1
	MOVF	0C,0
	ADDWF	13,1
	BTFSC	3,0
	DECF	12,1
	MOVF	13,0	;omeji na 6 bitov za sinusno tabelo (8 ukazov)
	ANDLW	3F
	MOVWF	09
	BSF	3,5	;postavi PAGE1 - precitaj EEPROM(9)
	BSF	8,0	;EECON1 RD
	BCF	3,5	;postavi PAGE0
	MOVF	8,0
	MOVWF	6	;vsebina v RB0-7=DAC
	NOP		;polnilo za 24-10-8-4=2ukaza
	NOP
	MOVF	12,0	;pogoj za konec zanke (4 ukazi)	
	BTFSS	3,2
	GOTO	PISKAC
	MOVLW	48	;cakanje 90ms=9*2048*12ukazov
	MOVWF	13
	CLRF	14
PISKAC1	MOVLW	80	;zanka 12 ukazov
	MOVWF	6	;tisina na DAC
	NOP		;polnilo 4 ukazi
	NOP
	NOP
	NOP
	DECF	14,1	;stevec zanke 6ukazov
	BTFSC	3,2
	DECF	13,1
	BTFSS	3,2
	GOTO	PISKAC1
	RETURN

;*** Nastavi konfiguracijo PICa 16F84 ***
	ORG	2007	;naslov konfiguracijske besede
	DW	1A	;CP=OFF, PWRTE=OFF, WDT=OFF, OSC=HS

;*** Vsebina EEPROMa sinusna tabela ***
	ORG	2100
	DW	80	;0
	DW	8C
	DW	99
	DW	0A5
	DW	0B1
	DW	0BC
	DW	0C7
	DW	0D1
	DW	0DA	;8
	DW	0E2
	DW	0EA
	DW	0F0
	DW	0F5
	DW	0FA
	DW	0FD
	DW	0FE
	DW	0FF	;16
	DW	0FE
	DW	0FD
	DW	0FA
	DW	0F5
	DW	0F0
	DW	0EA
	DW	0E2
	DW	0DA	;24
	DW	0D1
	DW	0C7
	DW	0BC
	DW	0B1
	DW	0A5
	DW	99
	DW	8C
	DW	80	;32
	DW	74
	DW	67
	DW	5B
	DW	4F
	DW	44
	DW	39
	DW	2F
	DW	26	;40
	DW	1E
	DW	16
	DW	10
	DW	0B
	DW	6
	DW	3
	DW	2
	DW	1	;48
	DW	2
	DW	3
	DW	6
	DW	0B
	DW	10
	DW	16
	DW	1E
	DW	26	;56
	DW	2F
	DW	39
	DW	44
	DW	4F
	DW	5B
	DW	67
	DW	74
	END

;*** Konec programa ***
	